﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Web.Services;
using System.Web.Script.Services;

namespace ProjectManagementTool
{
    public class TaskData
    {
        private int _TaskId;
        public int TaskId
        {
            get { return _TaskId; }
            set { _TaskId = value; }
        }
        private string _TaskName;
        public string TaskName
        {
            get { return _TaskName; }
            set { _TaskName = value; }
        }
        private int _ParentId;
        public int ParentId
        {
            get { return _ParentId; }
            set { _ParentId = value; }
        }
        private string _StartDate;
        public string StartDate
        {
            get { return _StartDate; }
            set { _StartDate = value; }
        }
        private string _EndDate;
        public string EndDate
        {
            get { return _EndDate; }
            set { _EndDate = value; }
        }
        private int _Duration;
        public int Duration
        {
            get { return _Duration; }
            set { _Duration = value; }
        }

        public string Predecessor { get; set; }
        public int ResourceId { get; set; }
        public int Progress { get; set; }
        public int TeamId { get; set; }
        public int RoleId { get; set; }
        public int EstManHours { get; set; }
        public bool Investigate { get; set; }
        public int StatusId { get; set; }
      
    }

    public class TeamData
    {
        public int TeamId { get; set; }
        public string TeamName { get; set; }
    }

    public class RoleData
    {
        public int RoleId { get; set; }
        public string RoleName { get; set; }
    }

    public class ResourceInfo
    {
        public int ResourceId { get; set; }
        public string ResourceName { get; set; }
    }

    public class StatusData
    {
        public int StatusId { get; set; }
        public string StatusName { get; set; }
    }

    public partial class ActGantt : System.Web.UI.Page
    {
        public PolkIT.DAL Dal = new PolkIT.DAL();
        public string ProjId { get { return Session["ProjId"].ToString(); } }
        public string ProjName { get { return Session["ProjectName"].ToString(); } }

        protected void Page_Load(object sender, EventArgs e)
        {            
            if (!IsPostBack)
            {
                GetPercentComp();
                if (Session["ProjectTaskType"].ToString() == "1")
                {
                    RadTabStrip1.Tabs[3].Visible = false;
                    RadTabStrip1.Tabs[4].Visible = false;                    
                }
                else
                {
                    RadTabStrip1.Tabs[3].Visible = true;
                    RadTabStrip1.Tabs[4].Visible = true;                    
                }  
                String getganttData = "SELECT * FROM [GanttData] where ProjectId = @ProjectId ";
                SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);
                conn.Open();

                List<TaskData> taskdataCollection = new List<TaskData>();                

                using (SqlCommand scmd = new SqlCommand(getganttData, conn))
                {
                                       scmd.Parameters.Add(new SqlParameter("@ProjectId", Session["ProjId"].ToString()));

                    SqlDataReader sdr = scmd.ExecuteReader();
                    while (sdr.Read())
                    {
                        taskdataCollection.Add(new TaskData
                        {
                            TaskId = sdr.GetInt32(sdr.GetOrdinal("TaskId")),
                            TaskName = sdr.GetString(sdr.GetOrdinal("TaskName")),
                            StartDate = Convert.ToString(sdr.GetDateTime(sdr.GetOrdinal("StartDate"))),
                            EndDate = Convert.ToString(sdr.GetDateTime(sdr.GetOrdinal("EndDate"))),
                            Duration = Convert.ToInt32(sdr.GetOrdinal("Duration")),
                            Predecessor = sdr.IsDBNull(sdr.GetOrdinal("Predecessor")) ? string.Empty : sdr.GetString(sdr.GetOrdinal("Predecessor")),
                            ResourceId = sdr.IsDBNull(sdr.GetOrdinal("ResourceId")) ? 0 : sdr.GetInt32(sdr.GetOrdinal("ResourceId")),
                            Progress = sdr.IsDBNull(sdr.GetOrdinal("Progress")) ? 0 : Convert.ToInt32(sdr.GetString(sdr.GetOrdinal("Progress"))),
                            TeamId = sdr.IsDBNull(sdr.GetOrdinal("TeamId")) ? 0 : sdr.GetInt32(sdr.GetOrdinal("TeamId")),
                            RoleId = sdr.IsDBNull(sdr.GetOrdinal("RoleId")) ? 0 : sdr.GetInt32(sdr.GetOrdinal("RoleId")),
                            EstManHours = sdr.IsDBNull(sdr.GetOrdinal("EstimatedManHours")) ? 0 : sdr.GetInt32(sdr.GetOrdinal("EstimatedManHours")),
                            Investigate = sdr.IsDBNull(sdr.GetOrdinal("Investigate")) ? false : sdr.GetBoolean(sdr.GetOrdinal("Investigate")),
                            StatusId = sdr.IsDBNull(sdr.GetOrdinal("Status")) ? 0 : sdr.GetInt32(sdr.GetOrdinal("Status")),
                            ParentId = sdr.GetInt32(sdr.GetOrdinal("ParentId"))
                            });
                    }
                }
                conn.Close();

                Gantt1.DataSource = taskdataCollection;
                Gantt1.DataBind();

            }
        }

        protected void GetPercentComp()
        {
            string status = Dal.dbConnect(PolkIT.DAL.dbType.SqlServer, ConfigurationManager.AppSettings["SQLServerConnection"].ToString());
            if (status == "Successful")
            {
                string getComp = @"SELECT 
	                                CASE 
		                                WHEN NOT (SUM(cast(Progress as int)) / COUNT(TaskId) IS NULL) 
		                                THEN ROUND(SUM(cast(Progress as int)) / COUNT(TaskId) , 2 , 1) 
		                                else 0 
	                                end as PercentComplete 
                                From ganttData 
                                where projectid = " + Session["ProjId"].ToString();
                //                string getComp = @"SELECT 
                //	                                CASE 
                //		                                WHEN NOT (SUM(cast(Progress as int)) / COUNT(TaskId) IS NULL) 
                //		                                THEN cast(ROUND(SUM(cast(Progress as int)) / COUNT(TaskId) , 2 , 1) as numeric(3,2))
                //		                                else 0 
                //	                                end as PercentComplete 
                //                                From ganttData 
                //                                where projectid = " + Session["ProjId"].ToString();

                String CompResult = Dal.ExecuteScalarSQLCommand(PolkIT.DAL.dbType.SqlServer, getComp);

                Dal.dbClose(PolkIT.DAL.dbType.SqlServer);
                lblComp.Text = CompResult + "% Complete";
                //lblComp.Text =  CompResult.Substring(0, CompResult.IndexOf(".") + 3) + "% Complete";
            }
            else
            {
                lblComp.Text = "0% Complete";

            }
        }

        public void Update(TaskData Task)
        {
            //Update Edited TaskDetails
            //Using UPDATE SQL Query to Save the Modified taskData into the Table

            int IDNumber = Task.TaskId;

            string cmdString = @"UPDATE GanttData SET TaskId=@TaskId, TaskName=@TaskName,StartDate=@StartDate,EndDate=@EndDate,
                                        Duration=@Duration,Progress=@Progress, ParentId=@ParentId, Predecessor=@Predecessor,
                                        TeamId=@TeamId, RoleId=@RoleId, ResourceId=@ResourceId, Status=@StatusId, EstimatedManHours=@EstManHours,
                                        Investigate=@Investigate
                                        WHERE TaskId = '" + IDNumber + "' and ProjectId = @ProjectId";

            SqlConnection con = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);
                sqlCommand.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());

                // dropdown
                if (Task.TeamId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@TeamId", Task.TeamId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@TeamId", Task.TeamId);
                }

                // dropdown
                if (Task.RoleId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@RoleId", Task.RoleId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@RoleId", Task.RoleId);
                }

                // dropdown
                if (Task.ResourceId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@ResourceId", Task.ResourceId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ResourceId", Task.ResourceId);
                }

                // dropdown
                if (Task.ResourceId == 0 && Task.Investigate == false)
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 1;
                }
                else if (Task.ResourceId > 0 && Task.Investigate == true)
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 2;
                    SqlCommand sqlCommand3 = new SqlCommand("Update ProjectTask Set Status = 2 where ProjectId = @ProjectId", con);
                    sqlCommand3.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());
                    sqlCommand3.ExecuteNonQuery();
                }
                else if (Task.ResourceId > 0 && Task.Investigate == false)
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 3;
                    SqlCommand sqlCommand3 = new SqlCommand("Update ProjectTask Set Status = 3 where ProjectId = @ProjectId", con);
                    sqlCommand3.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());
                    sqlCommand3.ExecuteNonQuery();
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId);
                }

                sqlCommand.Parameters.AddWithValue("@EstManHours", Task.EstManHours);
                sqlCommand.Parameters.AddWithValue("@Investigate", Task.Investigate);
                //    sqlCommand.Parameters.AddWithValue("@ResourceId", Task.ResourceId.Count == 0 ? "0" : string.Join(",",  Task.ResourceId.Select(r=> r)));
                if (Task.ParentId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }
                if (Task.Predecessor == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor).Value = "";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor);
                }

                int numb = sqlCommand.ExecuteNonQuery();
            }
            con.Close();
        }


        public void Add(TaskData Task)
        {
            //Here Task is the added New Task
            //Add Task 
            //Using INSERT Query to add the New Record to SQL Table

            string cmdString = @"INSERT INTO GanttData ([TaskName],[TaskId],[StartDate],[EndDate],[Duration],[Progress],
                                [ParentId],[Predecessor],[TeamId],[RoleId],[ResourceId],[Status],[EstimatedManHours],[Investigate], [ProjectId]) " +
                                @"VALUES(@TaskName,@TaskId,@StartDate,@EndDate,@Duration,@Progress,
                                @ParentId,@Predecessor,@TeamId,@RoleId,@ResourceId,@StatusId,@EstManHours,@Investigate, @ProjectId)";


            SqlConnection con = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.TaskName);
                sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.Progress);
                sqlCommand.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());
                // dropdown
                if (Task.TeamId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@TeamId", Task.TeamId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@TeamId", Task.TeamId);
                }

                // dropdown
                if (Task.RoleId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@RoleId", Task.RoleId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@RoleId", Task.RoleId);
                }

                // dropdown
                if (Task.ResourceId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@ResourceId", Task.ResourceId).Value = 0;
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ResourceId", Task.ResourceId);
                }

                // dropdown
                if (Task.ResourceId == 0 && Task.Investigate == false)
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 1;
                }
                else if (Task.ResourceId > 0 && Task.Investigate==true)
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 2;
                    SqlCommand sqlCommand3 = new SqlCommand("Update ProjectTask Set Status = 2 where ProjectId = @ProjectId", con);
                    sqlCommand3.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());
                    sqlCommand3.ExecuteNonQuery();
                }
                else if (Task.ResourceId > 0 && Task.Investigate == false)
                { 
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId).Value = 3;
                    SqlCommand sqlCommand3 = new SqlCommand("Update ProjectTask Set Status = 3 where ProjectId = @ProjectId", con);
                    sqlCommand3.Parameters.AddWithValue("@ProjectId", Session["ProjId"].ToString());
                    sqlCommand3.ExecuteNonQuery();
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@StatusId", Task.StatusId);
                }

                sqlCommand.Parameters.AddWithValue("@EstManHours", Task.EstManHours);
                sqlCommand.Parameters.AddWithValue("@Investigate", Task.Investigate);

                if (Task.ParentId == 0)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }
                if (Task.Predecessor == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor).Value = "";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predecessor);
                }

                int test = sqlCommand.ExecuteNonQuery();
            }

            con.Close();

        }

        public void Delete(TaskData Task)
        {
            //Delete Task 
            //Using Delete Query to delete Record from SQL Table

            int IDNumber = Task.TaskId;
            SqlConnection con = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);//connectionString
            con.Open();
            SqlCommand cmd = new SqlCommand("delete from GanttData where TaskId = '" + IDNumber + "' and ProjectId = " + Session["ProjId"].ToString(), con);
            int result = cmd.ExecuteNonQuery();
            con.Close();

        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static IEnumerable<object> GetTeams()
        {
            String getganttData = "SELECT TeamId, TeamName FROM [Teams] ORDER BY TeamName";
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);
            conn.Open();

            List<TeamData> teamDataCollection = new List<TeamData>();

            using (SqlCommand scmd = new SqlCommand(getganttData, conn))
            {
                SqlDataReader sdr = scmd.ExecuteReader();
                while (sdr.Read())
                {
                    teamDataCollection.Add(new TeamData
                    {
                        TeamId = sdr.GetInt32(sdr.GetOrdinal("TeamId")),
                        TeamName = sdr.GetString(sdr.GetOrdinal("TeamName"))
                    });
                }
            }
            conn.Close();

            return teamDataCollection;
        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static IEnumerable<object> GetRoles()
        {
            String getganttData = "SELECT RoleId, RoleName FROM [Roles] ORDER BY RoleName";
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);
            conn.Open();

            List<RoleData> roleDataCollection = new List<RoleData>();

            using (SqlCommand scmd = new SqlCommand(getganttData, conn))
            {
                SqlDataReader sdr = scmd.ExecuteReader();
                while (sdr.Read())
                {
                    roleDataCollection.Add(new RoleData
                    {
                        RoleId = sdr.GetInt32(sdr.GetOrdinal("RoleId")),
                        RoleName = sdr.GetString(sdr.GetOrdinal("RoleName"))
                    });
                }
            }
            conn.Close();

            return roleDataCollection;
        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static IEnumerable<object> GetResources()
        {
            String getganttData = "SELECT ContactId AS ResourceId, ContactLastName + ', ' + ContactFirstName AS ResourceName FROM [Names] ORDER BY ContactLastName, ContactFirstName";
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);
            conn.Open();

            List<ResourceInfo> resourceDataCollection = new List<ResourceInfo>();

            using (SqlCommand scmd = new SqlCommand(getganttData, conn))
            {
                SqlDataReader sdr = scmd.ExecuteReader();
                while (sdr.Read())
                {
                    resourceDataCollection.Add(new ResourceInfo
                    {
                        ResourceId = sdr.GetInt32(sdr.GetOrdinal("ResourceId")),
                        ResourceName = sdr.GetString(sdr.GetOrdinal("ResourceName"))
                    });
                }
            }
            conn.Close();

            return resourceDataCollection;
        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static IEnumerable<object> GetStatuses()
        {
            String getganttData = "SELECT PSId as StatusId, Status as StatusName FROM [ProjectStatusTypes] ORDER BY Status";
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["PMTestConnectionString"].ConnectionString);
            conn.Open();

            List<StatusData> StatusDataCollection = new List<StatusData>();

            using (SqlCommand scmd = new SqlCommand(getganttData, conn))
            {
                SqlDataReader sdr = scmd.ExecuteReader();
                while (sdr.Read())
                {
                    StatusDataCollection.Add(new StatusData
                    {
                        StatusId = sdr.GetInt32(sdr.GetOrdinal("StatusId")),
                        StatusName = sdr.GetString(sdr.GetOrdinal("StatusName"))
                    });
                }
            }
            conn.Close();

            return StatusDataCollection;
        }


        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static void AddIt(TaskData record)
        {
            ActGantt wf2 = new ActGantt();
            wf2.Add(record);
        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static void UpdateIt(TaskData record)
        {
            ActGantt wf2 = new ActGantt();
            wf2.Update(record);

        }

        [WebMethod]
        [ScriptMethod(UseHttpGet = true)]
        public static void DeleteIt(TaskData record)
        {
            ActGantt wf2 = new ActGantt();
            wf2.Delete(record);

        }
    }
}